'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

exports.__esModule = true;
exports['default'] = traverse;

function traverse(node, visitor, parent) {
  if (!node) {
    return node;
  }

  // Duplicate node to avoid mutations
  node = _extends({}, node);

  var type = node.type;
  switch (type) {
    case 'Query':
      node.fields = node.fields.map(function (n) {
        return traverse(n, visitor, node);
      });
      break;

    case 'Field':
      node.params = node.params.map(function (n) {
        return traverse(n, visitor, node);
      });
      node.fields = node.fields.map(function (n) {
        return traverse(n, visitor, node);
      });
      break;

    case 'Argument':
      node.value = traverse(node.value, visitor, node);
      break;
  }

  if (typeof visitor[type] === 'function') {
    var repl = visitor[type](node, parent);
    if (repl !== void 0) {
      node = repl;
    }
  }

  return node;
}

module.exports = exports['default'];